<?php
/**
 * This file is modify WC meta-boxes-order.min.js script file
 * In class-filo-admin-assets.php we deregister original WC wc-admin-order-meta-boxes script,
 * and register this file instead.
 * This is load the same script with some modifications.
 * 
 * Modifications:
 * - eliminate window.confirm( woocommerce_admin_meta_boxes.calc_line_taxes ) confirmation question
 * - eliminate window.confirm( woocommerce_admin_meta_boxes.calc_totals ) confirmation question
 */

// we do not use filo_individual_page here, because it is a simple replace, and do not need WordPress bootstrap
// TEST: http://yoursite.com/wp-content/plugins/filogy-framework/assets/js/admin/meta-boxes-order-filochange.js.php
// OLD TEST: http://yoursite.com/?filo_individual_page=meta_boxes_order_js
// http://php.net/manual/en/function.ob-end-flush.php

// ----------------- copied from wsl-core-functions.php BEGIN -----------------

if ( ! function_exists ( 'wsl_str_replace_after_string' ) ) {
	/**
	 * str replace after that part of the subject, that begins with the start string
	 *
	 */
	function wsl_str_replace_after_string( $search, $replace , $subject, $count = null, $start_string ) {
		
		//string strstr(string $haystack, string $needle, [bool $before])
		
		// if no start string found, then return the original subject
		if ( strpos( $subject, $start_string ) ===  false ) {
			return $subject;
		}
		
		//subject before the first character of start string
		$before = strstr( $subject, $start_string, true );
		
		//subject after the last character of start string, we have to replace in this
		$after = strstr( $subject, $start_string, false );
		
		if ( $count == null )
			$after = str_replace( $search, $replace, $after );
			else
				$after = wsl_str_replace_first( $search, $replace, $after );
				
				return $before . $after;
				
	}
}

if ( ! function_exists ( 'wsl_str_replace_first' ) ) {
	/**
	 * string replace of the first occurrence
	 */
	function wsl_str_replace_first( $search, $replace, $subject ) {
		$position = strpos( $subject, $search );
		if ( $position !== false ) {
			$subject = substr_replace( $subject, $replace, $position, strlen($search) );
		}
		return $subject;
	}
}

// ----------------- copied from wsl-core-functions.php END -----------------


// ----------------- START -----------------

/**
 * Replace callback function
 */
function callback($buffer)
{
	
	// after succcessful order items task (add item, save, add tax, delete item, ...) a trigger is inserted
	// (more triggers are inserted into different places)
	// it is necessary for recalculate taxes (especially shipping tax when shipping cost is changed), from WC 3.4.4 it is built in there
	// NEW IN WC 3.3.3, there was: wc_meta_boxes_order_items.reloaded_items();
	// in WC 3.4.4, it is changed to: wc_meta_boxes_order_items.reloaded_items();
	$buffer = str_replace(
		"wc_meta_boxes_order_items.reloaded_items();", 														//$search
		"wc_meta_boxes_order_items.reloaded_items();
		$('#woocommerce-order-items').trigger('order_items_ajax_task_finished'); //Add filogy (100)
		$('#woocommerce-order-items').trigger('order_items_ajax_task_finished_except_recalculate');", //$replace
		$buffer
	);
	
	// after an ajax tax is finished, we call recalculate button to recalculate taxex, exept after recalculation, becaus we do not need an infinite loop of recalculations
	// Thus the pre added (into more places) string is removed from the recalculation part (from one place: woocommerce_calc_line_taxes ajax action) 
	//NEW IN WC 3.3.3
	// WC 3.4.4 ok, and NEEDED
	$buffer = wsl_str_replace_after_string(
	 "$('#woocommerce-order-items').trigger('order_items_ajax_task_finished_except_recalculate');",	//$search
	 "", 																		//$replace (to empty)
	 $buffer, 																	//$subject
	 1,																			//$count
	 "action:   'woocommerce_calc_line_taxes'," 								//$start_string - the first occurrence after this string
	 );
	
	// disable calc_totals confirmation window (the conformation belonging to Recalculate button)
	// WC 3 ok
	// WC 3.3.3 ok, and NEEDED
	$buffer = str_replace(
		"if ( window.confirm( woocommerce_admin_meta_boxes.calc_totals ) ) {", 
		"if ( true ) { //Add filogy (020)", 
		$buffer
	);
	
	return $buffer;
	
}

header('Content-type: application/javascript');
ob_start("callback");
include( '../../../../woocommerce/assets/js/admin/meta-boxes-order.js' );
ob_end_flush();



