<?php
if ( !defined('ABSPATH') ) exit;

if ( !class_exists('FILO_Admin_List_Table_Finadoc_FW') ) :
	
/**
 * FILO_Admin_List_Table_Finadoc
 * 
 * List tables: finadoc
 *
 * @package     Filogy/Admin
 * @subpackage 	Financials
 * @category    Admin
 */

if ( class_exists( 'FILO_Admin_List_Table_Finadoc_FW', false ) ) {
	return;
}

class FILO_Admin_List_Table_Finadoc_FW {
	
	
	/**
	 * Change the label when searching orders.
	 *
	 * It works only for 'shop_order'-s, we apply the same for any kind of finadocs, exept shop_order (which is handnled by WC)
	 * @based_on class-wc-admin-list-table-orders.php COPY
	 * 
	 * @param mixed $query Current search query.
	 * @return string
	 */
	public function search_label( $query ) {
		global $pagenow, $typenow;
		global $filo_post_types_financial_documents; // ADD RaPe
		
		//wsl_log(null, 'class-filo-admin-list-table-finadoc-fw.php search_label 0: ' .  wsl_vartotext( get_query_var( 'shop_order_search' ) ));
		//wsl_log(null, 'class-filo-admin-list-table-finadoc-fw.php search_label $typenow: ' .  wsl_vartotext( get_query_var( $typenow ) ));
		//wsl_log(null, 'class-filo-admin-list-table-finadoc-fw.php search_label $pagenow: ' .  wsl_vartotext( get_query_var( $pagenow ) ));

		// MODIFY RaPe
		//if ( 'edit.php' !== $pagenow || 'shop_order' !== $typenow || ! get_query_var( 'shop_order_search' ) || ! isset( $_GET['s'] ) ) { // WPCS: input var ok.
		if ( 'edit.php' !== $pagenow || ! get_query_var( 'shop_order_search' ) || ! isset( $_GET['s'] ) 
			|| ( ! in_array( $typenow, $filo_post_types_financial_documents) and $typenow != 'filo_case' ) || $typenow == 'shop_order'// MODIFY RaPe - this works only for finadocs, exept shop order
			) { // WPCS: input var ok.
			return $query;
		}
		
		//wsl_log(null, 'class-filo-admin-list-table-finadoc-fw.php search_label $_GET[s]: ' .  wsl_vartotext( $_GET['s'] ));
		
		return wc_clean( wp_unslash( $_GET['s'] ) ); // WPCS: input var ok, sanitization ok.
	}
	
	
	/**
	 * Search custom fields as well as content.
	 * 
	 * It works only for 'shop_order'-s, we apply the same for any kind of finadocs, exept shop_order (which is handnled by WC)
	 * @based_on class-wc-admin-list-table-orders.php COPY
	 *
	 * @param WP_Query $wp Query object.
	 */
	// We implement it in each edit list (finadoc, case, trans match), that is why it is not used here
	/*
	public function search_custom_fields( $wp ) {
		global $pagenow, $typenow;
		global $filo_post_types_financial_documents; // ADD RaPe
		
		wsl_log(null, 'class-filo-admin-list-table-finadoc-fw.php search_custom_fields $pagenow: ' .  wsl_vartotext( $pagenow ));
		
		// MODIFY RaPe
		//if ( 'edit.php' !== $pagenow || empty( $wp->query_vars['s'] ) || 'shop_order' !== $wp->query_vars['post_type'] || ! isset( $_GET['s'] ) ) { // WPCS: input var ok. 
		if ( 'edit.php' !== $pagenow || empty( $wp->query_vars['s'] ) || ! isset( $_GET['s'] ) 
			|| ( ! in_array( $wp->query_vars['post_type'], $filo_post_types_financial_documents) and ! $typenow == 'filo_case' ) || $wp->query_vars['post_type'] == 'shop_order'// MODIFY RaPe - this works only for finadocs, exept shop order
			) { // WPCS: input var ok.
			return;
		}
		
		$post_ids = wc_order_search( wc_clean( wp_unslash( $_GET['s'] ) ) ); // WPCS: input var ok, sanitization ok.
		wsl_log(null, 'class-filo-admin-list-table-finadoc-fw.php search_custom_fields $post_ids: ' .  wsl_vartotext( $post_ids ));
		
		if ( ! empty( $post_ids ) ) {
			// Remove "s" - we don't want to search order name.
			unset( $wp->query_vars['s'] );
			
			// so we know we're doing this.
			$wp->query_vars['shop_order_search'] = true;
			
			// Search by found posts.
			$wp->query_vars['post__in'] = array_merge( $post_ids, array( 0 ) );
		}
		
	}*/

}
endif;