<?php

if ( !defined('ABSPATH') ) exit;

if ( !class_exists('FILO_Admin_Post_Types') ) :

/**
 * Financial Document List Table
 *
 * FILO_Admin_Finadoc_List_Table Class
 *
 * Handles the edit posts views and some functionality on the edit post screen for WC post types.
 * The name of this class may (FILO_Admin_Finadoc_List_Table (class-filo-admin-finadoc-list-table.php)), but it is financial_document specific
 * 
 * @package     Filogy/Admin
 * @subpackage 	Financials
 * @category    Admin
 */
 
class FILO_Admin_Post_Types extends WC_Admin_Post_Types {

	/**
	 * Override the standard setup screen function
	 * 
	 * This is needed for displaying our custom finadocs similarly shop orders in the order list screen
	 *
	 */
	public function setup_screen() {
		$screen_id = false;
		
		wsl_log(null, 'class-filo-admin-post-types.php setup_screen 0: ' .  wsl_vartotext( '' ));
		
		if ( function_exists( 'get_current_screen' ) ) {
			$screen    = get_current_screen();
			$screen_id = isset( $screen, $screen->id ) ? $screen->id : '';
		}
		
		//if screen-id contains edit- prefix (thus it is an edit page)
		if ( strpos( $screen_id , 'edit-') === 0 ) {

			//remove edit- prefix, for the next part, because $finadoc_screens does not contain this prefix
			$screen_id_1 = str_replace('edit-', '', $screen_id);
			
			wsl_log(null, 'class-filo-admin-post-types.php setup_screen $screen_id_1: ' .  wsl_vartotext( $screen_id_1 ));
			
			$finadoc_screens = FILO_Post_Types::get_finadoc_screen_ids();
			
			wsl_log(null, 'class-filo-admin-post-types.php setup_screen $finadoc_screens: ' .  wsl_vartotext( $finadoc_screens ));
			
			// we use class-filo-admin-list-table-finadocs for finadoc screens
			if ( in_array( $screen_id_1, $finadoc_screens ) and $screen_id_1 != 'filo_case' ) {
				include_once( 'list-tables/class-filo-admin-list-table-finadoc.php' );
				new FILO_Admin_List_Table_Finadoc();
			}
			
			// table handlers is only loaded once (like in original WooCommerce function)
			remove_action( 'current_screen', array( $this, 'setup_screen' ) );
			remove_action( 'check_ajax_referer', array( $this, 'setup_screen' ) );
			
		}
	}
	
}

endif;

new FILO_Admin_Post_Types();