<?php
/**
 * WooCommerce product variation class.
 *
 * @package WooCommerce/Classes
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Product Variation Class.
 *
 * The WooCommerce product variation class handles product variation data.
 * 
 * FILO_Product_Simple and FILO_Product_Variation are the SAME (exept class name end extends) COPY
 *
 * @class       WC_Product_Variation
 * @version     3.0.0
 * @package     WooCommerce/Classes
 * @category    Class
 * @author      WooThemes
 */
class FILO_Product_Simple extends WC_Product_Simple {

	//[price] => 23
	//[regular_price] => 23
	//[sale_price] =>
	
	/**
	 * Override the default constructor to set custom defaults.
	 *
	 * @param int|WC_Product|object $product Product to init.
	 */
	public function __construct( $product = 0 ) {
		
		parent::__construct( $product );
		
		$this->data['purchase_price'] = get_post_meta($product, '_purchase_price', $single = true);
		$this->data['standard_inventory_item_cost'] = get_post_meta($product, '_standard_inventory_item_cost', $single = true);
		//_vendor_catalog_no
		
		//wsl_log(null, 'class-filo-product-variation.php __construct $this: ' . wsl_vartotext($this));
		
	}
	
	/**
	 * Price
	 * 
	 * This is just a special purpose solution, to set the attribute on this object instance to add this product to a finadoc. If it is a purchase type of doc, then replace the price to the purchase price in ajac add item function. 
	 *
	 * @param string $value
	 */
	public function set_price_direct_force( $value ) {
		$value = wc_format_decimal( $value );
		//$this->subtotal = $value;
		$this->data['price'] = $value;
		
	}
	
	/**
	 * Regular Price
	 *
	 * This is just a special purpose solution, to set the attribute on this object instance to add this product to a finadoc. If it is a purchase type of doc, then replace the price to the purchase price in ajac add item function.
	 *
	 * @param string $value
	 */
	public function set_regular_price_direct_force( $value ) {
		$value = wc_format_decimal( $value );
		//$this->total = $value;
		$this->data['regular_price'] = $value;
	}

	/**
	 * Sale Price
	 *
	 * This is just a special purpose solution, to set the attribute on this object instance to add this product to a finadoc. If it is a purchase type of doc, then replace the price to the purchase price in ajac add item function.
	 *
	 * @param string $value
	 */
	public function set_sale_price_direct_force( $value ) {
		$value = wc_format_decimal( $value );
		//$this->total = $value;
		$this->data['sale_price'] = $value;
	}

	
	
	/**
	 * get_purchase_price_x
	 * 
	 * This is a special solution for changin sales price to purchase price
	 * This is not the standard WC way, not uses data_store methods
	 */
	public function get_purchase_price_x() {
		$return = get_post_meta($this->get_id(), '_purchase_price', $single = true);
		return $return;
	}

	/**
	 * get_standard_inventory_item_cost_x
	 *
	 * This is a special solution for changin sales price to purchase price
	 * This is not the standard WC way, not uses data_store methods
	 */
	public function get_standard_inventory_item_cost_x() {
		$return = get_post_meta($this->get_id(), '_standard_inventory_item_cost', $single = true);
		return $return;
	}
	
	
	
}
